bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/config/routes.rb
Rails.application.routes.draw do
  resources :capys, only: [:new, :create, :show, :index] do
    resources :parties, only: [:new, :create]
  end

  resources :parties, only: [:show]

  root to: 'capys#index'
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/models/attendance.rb
# == Schema Information
#
# Table name: attendances
#
#  id          :integer          not null, primary key
#  capy_id :integer
#  party_id    :string
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class Attendance < ActiveRecord::Base
  validates :capy_id, :party_id, presence: true
  validates :party_id, uniqueness: { scope: :capy_id,
    message: 'Capys cannot have two invites to the same party.' }
    
  belongs_to :capy
  belongs_to :party
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/models/capy.rb
# == Schema Information
#
# Table name: capys
#
#  id         :integer          not null, primary key
#  name       :string           not null
#  color      :string           not null
#  created_at :datetime         not null
#  updated_at :datetime         not null
#

class Capy < ActiveRecord::Base
  validates :name, :color, presence: true
  validates :name, uniqueness: true
  validate :color_not_green

  has_many :parties, inverse_of: :capy
  has_many :attendances
  has_many :parties_to_attend, through: :attendances, source: :party

  def self.capys_of_the_rainbow
    Capy.where(color: 'rainbow')
  end

  def color_not_green
    errors[:color] << "cannot be green!!" if color == 'green'
  end
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/models/party.rb
# == Schema Information
#
# Table name: parties
#
#  id          :integer          not null, primary key
#  capy_id :integer          not null
#  occasion    :string           not null
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class Party < ActiveRecord::Base
  validates :capy, presence: true
  belongs_to :capy, inverse_of: :parties

  has_many :attendances
  has_many :guests, through: :attendances, source: :capy
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/controllers/capys_controller.rb
class CapysController < ApplicationController
  def index
    @capys = Capy.all
    render :index
  end

  def show
    @capy = Capy.includes(:parties).find(params[:id])
    render :show
  end

  def new
    @capy = Capy.new
    render :new
  end

  def create
    @capy = Capy.new(capy_params)

    if @capy.save
      redirect_to capy_url(@capy)
    else
      flash.now[:errors] = @capy.errors.full_messages
      render :new
    end
  end

  private

  def capy_params
    params.require(:capy).permit(:name, :color)
  end
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/controllers/parties_controller.rb
class PartiesController < ApplicationController
  def new
    @party = Party.new
    render :new
  end

  def create
    @party = Party.new(party_params)

    if @party.save
      render :show
    else
      flash.now[:errors] = @party.errors.full_messages
      render :new
    end
  end

  def show
    @party = Party.includes(:guests, :capy).find(params[:id])
    render :show
  end

  private

  def party_params
    params.require(:party).permit(:occasion, :capy_id)
  end
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/helpers/application_helper.rb
module ApplicationHelper
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/helpers/capys_helper.rb
module CapysHelper
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/helpers/parties_helper.rb
module PartiesHelper
end

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/views/capys/index.html.erb
<h1>Every Capy in Existence</h1>

<ul>
  <% @capys.each do |capy| %>
    <li><a href="<%= capy_url(capy) %>"><%= capy.name %></a></li>
  <% end %>
</ul>

<a href="<%= new_capy_url %>">Create a Capy</a>

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/views/capys/new.html.erb
<h1>New Capybara</h1>
<%= flash[:errors].join(", ") if flash[:errors] %>

<form action="<%= capys_url %>" method="post">
  <input type="hidden" name="authenticity_token" value="<%= form_authenticity_token %>">

  <label>name
    <input type="text" value="<%= @capy.name %>" name="capy[name]" />
  </label>

  <label>color
    <input type="text" value="<%= @capy.color %>" name="capy[color]" />
  </label>

  <input type="submit" value="Create Capy">
</form>

bootcamp-research/_bryce/W10D1/solutions/CapybaraParty/app/views/capys/show.html.erb
<img src="https://media.giphy.com/media/hi2kPofVMW70k/giphy.gif">

<br><br>

<h1><%= @capy.name %>'s Party Page</h1>

<h2>My current parties are:</h2>
<ul>
  <% @capy.parties.each do |party| %>
    <li><a href="<%= party_url(party) %>"><%= party.occasion %></a></li>
  <% end %>
</ul>